###################################################################################################
###################################################################################################
##                      Chain Reaction Pulsar v1.0 by USS Frontier from BCS: TC
##			Edited to Special Weapon Launcher by KrrKs
##
##  A special weapon script, based off StarTrek: Armada 2 Chain Reaction Pulsar special weapon(equipped on 
##  Akira Class ships). The Chain Reaction Pulsar is a special projectile that bounces between enemies, 
##  getting stronger at each hit, and of course dealing damage to the enemy ship he hits. After firing,
##  you will only be able to fire it again after 45 seconds after the Chain Reaction Pulsar previously fired ended.
##  It can hit a maximum of 26 ships (the first target and 25 bounces), and gets stronger whit each hit. 
##  And to you be able to fire the Chain Reaction Pulsar an enemy must be in range of at least 100Km (game units)
##  from you, and then another enemy must be in 100Km from the enemy ship that the torpedo hited and so on,
##  if there aren't any, the Chain Reaction Pulsar will end, and after 45 sec from ending you can use it again.
##  You can also goto the menu Configure>Controls>Ships after QuickBattle has begun and set a key to ChainReactionPulsar,
##  then, ingame, just press her and you will fire CRP.
##
##  Plugin Info: You set by the plugin: the ship hardpoint, from where to shoot CRP, and which torpedo script
##               to use for the CRP. See the plugin file or the readme for more info.
##
##  Credits: USS Frontier(me) for this script, BCS:TNG for help and training scripters in the BCS TrainingCorps,
##            Nighthawk for some help, Defiant for QBautostart and MLeo for Foundation Tech that introduced
##            me in making scripts for BC, for some functions/code I used here and for his KeyFoundation, needed
##            if you want to fire CRP by pressing a key. Plus, as Foundation Tech is based of in Apollo's ATP mod, then, 
##            Thanks Apollo!
##
##  Requirements: QBautostart 0.9.1 or higher, a Brain, a Ship that can use this and at least 2 enemies within 100Km of
##                 each other.
##
##  Permissions: Property of USS Frontier, just ask for permission and you can modify or use code from this,
##               if you are too lazy to ask permission and modify/use some code from here MAKE SURE TO GIVE PROPER 
##                CREDITS FOR ME (USS Frontier) AND THIS SCRIPT.
##
##  Note: the ocasional line of code commented out are for educatioanl purposes only, they needed to be removed
##        but as we can learn something from them they are just commented. DON'T CHANGE THEM.
###################################################################################################
###################################################################################################
import App
import MissionLib
import Lib.LibEngineering
import string

#some variables...
pButton = None
pMenu = None
pSWStatBut = None
pTarget = None
pFromShip = None
pTorp = None
pSet = None
TorpDmg = 0
etTimer = None
IsSWOnline = 0
ResetTimes = 0
Swarmlaunch = 0
Swarmnumber = 1  #It doesn't matter what number there is, it'll be resettet elsewere
#######################Variables that have something to do with the plugin#######################
PluginDict = {}
SWStatus = 0
SW_DISABLED = "Disabled"
SW_DESTROYED = "Destroyed"
SW_OPERATIONAL = "Operational"
#These 3 are for the IsCRPOnline variable. Probably peopleo will say its stupid to make 3 variables to be the 
#value of another, but as various functions will check if it is online or not, it's best to make it a variable than
#a number, because we remember clearly what is the value we need to check for it is a string instead of a number. well atleast for me, plus i didn't have any lag on Quickbattle beacuse of this so...
SW_OFFLINE = "Offline"
SW_ONLINE = "Online"
SW_CHARGING = "Charging"
#############################################################

#guess what
def init():
	#always when the player is set make the plugin check
	pMission = App.Game_GetCurrentGame().GetCurrentEpisode().GetCurrentMission()
	App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_SET_PLAYER, pMission, __name__ + ".CheckPlugin")


def SWKeyCheck(pObject, pEvent):
	global IsSWOnline, pButton
	#print "checking key"
	if CanPlayerUseSW() == 1:
		if SWStatus == SW_DISABLED or SWStatus == SW_DESTROYED:
			print "SW System is disabled or destroyed. Can't fire SW."
			return
		if (IsSWOnline == SW_OFFLINE and pButton.IsEnabled()):
			#print "key is OK"
			SpecialWeaponFire(pObject, pEvent)
			return
		else:
			#print "///SWOn=", IsSWOnline, "///ButEna=", pButton.IsEnabled()
			return

#again, guess what this does
def ReEnableSW(pObject, pEvent):
	global pButton, pSWStatBut, IsSWOnline
	pButton.SetEnabled()
	IsSWOnline = SW_OFFLINE
	pSWStatBut.SetName(GetSWStatButString())
	print "Special Weapon recharged."

#I really make things self-explain themselves right?
#this is called when you fire the CRP (press the button)
def SpecialWeaponFire(pObject, pEvent):
	global pButton, pSet, pTarget, pTorp, TorpDmg, IsSWOnline, PluginDict, SWStatus, Swarmlaunch, Swarmnumber
	pPlayer = MissionLib.GetPlayer()
	pPlayerID = pPlayer.GetObjID()

	if SWStatus == SW_DISABLED or SWStatus == SW_DESTROYED:
		print "SW System is disabled or destroyed. Can't fire SW."
		return

	#Check if player is cloaked
	if pPlayer.IsCloaked():
		print "Can't fire Special Weapon while cloaked!"
		return

	#Check the location from which to shoot SW
	pShootFrom = MissionLib.GetSubsystemByName(pPlayer, PluginDict['ShootFrom'])
	kPoint = pShootFrom.GetWorldLocation()
	
	#Check the players's target
	pTarget = pPlayer.GetTarget()
	if not pTarget:
		print "Can't fire Special Weapon without a target!"
		return
	else:
		pTargShip = App.ShipClass_Cast(pTarget)
		pHull = pTargShip.GetHull()
		if pHull.GetCondition() > 0:
			if not pTargShip.IsCloaked():
				pTargetID = pTarget.GetObjID()
			else:
				print "Target is cloaked, can't fire Special Weapon "
				return
		else:
			print "SpecialWeapon: Target is already destroyed or it is exploding."
			return

	#Check the distance between them
	if not (DistanceCheck(pPlayer, pTarget) <= 500):
		print "SpecialWeapon: Target out of range"
		return

	#And finally begin to set variables to fire the SW
	pSet = pPlayer.GetContainingSet()
	pSetName = pSet.GetName()

	VecsXY = VectorMath(pTarget.GetWorldLocation(), kPoint, pPlayer.GetWorldForwardTG())
	X = VecsXY[0]
	Y = VecsXY[1]

	#Firing the torpedo and play the sound
	TorpScript = __import__(PluginDict['Module'])
	pTorp = FireTorpFromPointWithVector(Y,X,TorpScript.__name__,pTargetID,pPlayerID,TorpScript.GetLaunchSpeed())
	PlayTorpLaunchSound(pTorp, pSet)
	TorpDmg = pTorp.GetDamage()
	pButton.SetDisabled()

	Swarmlaunch = Swarmlaunch + 1
	if (Swarmlaunch < Swarmnumber):
		DelayTimeSW = 0.33	
		etTimerSW = MissionLib.CreateTimer(Lib.LibEngineering.GetEngineeringNextEventType(), __name__ + ".SpecialWeaponFire", App.g_kUtopiaModule.GetGameTime() + DelayTimeSW, 0, 0)
	else:
		Swarmlaunch = 0
	
	#Ending the fire function: begin the loop and stuff
	IsSWOnline = SW_ONLINE   #This has to do with the key
	pSWStatBut.SetName(GetSWStatButString())
	DelayTime = 45	
	etTimer = MissionLib.CreateTimer(Lib.LibEngineering.GetEngineeringNextEventType(), __name__ + ".ReEnableSW", App.g_kUtopiaModule.GetGameTime() + DelayTime, 0, 0)


#the Terminate SW Loop func, guess what it does
def TerminateSWLoop(IsResetTerminate=None):
	global pSet, pTarget, pTorp, TorpDmg, pFromShip, pSWPStatBut, etTimer, IsSWOnline
	pSWStatBut.SetName(GetSWStatButString())
	if IsResetTerminate == None:
		print "Terminating Special Weapon Loop. 45 second to charge it again."
	
	pSet = None       #
	pTarget = None    #Nullifying all variables, 
	pTorp = None      # just to be sure
	TorpDmg = None    #
	pFromShip = None  #
	
	#remove the object exploding broadcast handler, but not the set_player handler!
	pMission = App.Game_GetCurrentGame().GetCurrentEpisode().GetCurrentMission()
	

def SWReset(pObject, pEvent):
	TerminateSWLoop(1)
	ReEnableSW(pObject, pEvent)


#From Mleo's FoundationTech, needed to create the new torp after the previous one bounces
def FireTorpFromPointWithVector(kPoint, kVector, pcTorpScriptName, idTarget, pShipID, fSpeed, TGOffset = None):
	pTarget = App.ShipClass_Cast(App.TGObject_GetTGObjectPtr(idTarget))
	pSet = pTarget.GetContainingSet()
	if not pSet:
		return None

	pTorp = App.Torpedo_Create(pcTorpScriptName, kPoint)
	pTorp.UpdateNodeOnly()

	pShip = App.ShipClass_Cast(App.TGObject_GetTGObjectPtr(pShipID))

	pTorp.SetTarget(idTarget)
	if not TGOffset and pShip:
		pTorp.SetTargetOffset(pShip.GetHull().GetPosition())
	else:
		pTorp.SetTargetOffset(TGOffset)
	pTorp.SetParent(pShipID)

	pSet.AddObjectToSet(pTorp, None)
	pTorp.UpdateNodeOnly()

	kTorpLocation = pTorp.GetWorldLocation()
	kTargetLocation = pTarget.GetWorldLocation()

	kTargetLocation.Subtract(kTorpLocation)
	kFwd = kTargetLocation
	kFwd.Unitize()
	kPerp = kFwd.Perpendicular()
	kPerp2 = App.TGPoint3()
	kPerp2.SetXYZ(kPerp.x, kPerp.y, kPerp.z)
	pTorp.AlignToVectors(kFwd, kPerp2)
	pTorp.UpdateNodeOnly()

	kSpeed = CopyVector(kVector)
	kSpeed.Unitize()
	kSpeed.Scale(fSpeed)
	pTorp.SetVelocity(kSpeed)

	return pTorp

#used in Mleo's FireTorpFromPointWithVector
def CopyVector(kVect):
	kCopy = App.TGPoint3()
	kCopy.SetXYZ(kVect.GetX(),kVect.GetY(),kVect.GetZ())
	return kCopy

#Credit for this goes to Mleo, from his Foundation Tech.
#This is for some vector calculation that are needed before using the FireTorpFromPointWithVector, ive made a func to return 
#the values needed because, well, its much more simpler than copying 19 lines of code before each time the FireTorp func woulda be used
def VectorMath(GotoCOOR, GoFromCOOR, GoFromNormal):
	X = GotoCOOR
	kVectNiWorldHitPoint = GoFromCOOR
	Y = App.TGPoint3()
	Y.SetX(kVectNiWorldHitPoint.x)
	Y.SetY(kVectNiWorldHitPoint.y)
	Y.SetZ(kVectNiWorldHitPoint.z)
	kVectNiWorldHitNormal = GoFromNormal
	N = App.TGPoint3()
	N.SetX(kVectNiWorldHitNormal.x)
	N.SetY(kVectNiWorldHitNormal.y)
	N.SetZ(kVectNiWorldHitNormal.z)
		
	X.Subtract(Y)
	X.Unitize()
	U = X.Cross(N)
	V = N.Cross(U)
	V.Unitize()
	V.Scale(-2.0*X.Dot(V))
	X.Add(V)
	
	return [X, Y]

#Mleo's FireTorpFromPointWithVector didn't played the launch sound of the torpedo, so i've made this
#out of the FireTorpFromPoint in MissionLib
def PlayTorpLaunchSound(TorpedoProp, SetProp):
	pcLaunchSound = TorpedoProp.GetLaunchSound()
	if pcLaunchSound != None:
		pSound = App.g_kSoundManager.GetSound(pcLaunchSound)
		if pSound != None:
			pSound.AttachToNode(TorpedoProp.GetNode())
			pSoundRegion = App.TGSoundRegion_GetRegion(SetProp.GetName())
			if pSoundRegion != None:
				pSoundRegion.AddSound(pSound)

			pSound.Play()

#a distance check, tah dah!!
def DistanceCheck(pObject1, pObject2):
	vDifference = pObject1.GetWorldLocation()
	vDifference.Subtract(pObject2.GetWorldLocation())

	return vDifference.Length()

#slightly modified MakeEnemyShipList from Mleo's FoundationTech
def MakeEnemyShipList():
	pGame = App.Game_GetCurrentGame()
	pEpisode = pGame.GetCurrentEpisode()
	pMission = pEpisode.GetCurrentMission()
	pEnemies = pMission.GetEnemyGroup()
	pPlayer = MissionLib.GetPlayer ()
	pPlayerID = pPlayer.GetObjID()
	lEnemyShips = []
	if pEnemies != None:
		ObjTuple = pEnemies.GetActiveObjectTupleInSet(pPlayer.GetContainingSet())
		if len(ObjTuple):
			for i in ObjTuple:
				pObj = App.ShipClass_Cast(i)
				if pObj:			
					lEnemyShips.append(pObj)

	return lEnemyShips

#Check if player's ship is capable of using CRP
def CheckPlugin(pObject, pEvent):
	global SWPluginDict, ResetTimes, Swarmnumber
	pPlayer = MissionLib.GetPlayer()
	# remove menu so no menus are duplicated and reset SW, to make sure all variables are properly set 
	if ResetTimes >= 1:
		SWReset(pObject, pEvent)
	RemoveMenu()
	# Get the currently used ship HP
	pPlugin = None
	pPlugin = GetShipType(pPlayer)
	try:
		# Import the module
		pModule = __import__("Custom.QBautostart.SpecialWeaponPlugins." + pPlugin)
		# Check module properties
		if hasattr(pModule, "SWPluginDict"):
			if not pModule.SWPluginDict.has_key('ShipHardpoint'):
				print "Error:", HPName, " SpecialWeapon plugin is invalid! It's missing the ShipHardpoint key!"
				return
			# All is ok, retrieve the value
			HPName = pModule.SWPluginDict['ShipHardpoint']
			# One final check before we add the menu
			if pPlugin == HPName:
				# All is well build the menu
				CreatePluginDict(pModule)
				BuildMenu()
				ResetTimes = ResetTimes + 1

				#if hasattr(pModule, "GetSwarm()"):
				try:
					Swarmnumber = pModule.GetSwarm()
				#else:
				except:
					print "Error: failure in loading Swarm attribute. Setting Swarmnumber to default value"
					Swarmnumber = 1

			# Give a console printout of an unsuccessfull Plugin Loading
			else:
				print "Error:", HPName, " ChainReactionPulsar plugin is invalid! Please consult the Readme for more info or contact USS Frontier"        
		else:
			# Also warn the user that something went wrong!
			print "Error:", HPName, " ChainReactionPulsar plugin is invalid! Please consult the Readme for more info or contact USS Frontier"
	except:
		#No plugins? do nothing
		return
            
#This is a modified CheckPlugin function, but instead of checking the plugin and removing/building the menu and other things
# this just returns 1 if the player ship can use CRP, if he can't use it return None
def CanPlayerUseSW():
	pPlayer = MissionLib.GetPlayer()
	pPlugin = GetShipType(pPlayer)
	try:
		pModule = __import__("Custom.QBautostart.SpecialWeaponPlugins." + pPlugin)
		if hasattr(pModule, "SWPluginDict"):
			if not pModule.SWPluginDict.has_key('ShipHardpoint'):
				return None
			HPName = pModule.SWPluginDict['ShipHardpoint']
			if pPlugin == HPName:
				#Yes, player can use SW
				return 1

			else:
				# No plugin
				return None
		else:
			# No plugin
			return None
	except:
		#No plugins
		return None

#here we create the plugin dict, and if user hasn't put a value to any key, we set it to default
def CreatePluginDict(pModule):
	global PluginDict, SWStatus, IsSWOnline
	PluginDict = {}
	Dict = pModule.SWPluginDict
	pPlayer = MissionLib.GetPlayer()
	######################################################
	#check the plugin dict key MODULE
	if not Dict.has_key('Module') or Dict['Module'] == None:
		print "Error:", Dict['ShipHardpoint'], "Special Weapon Plugin: Doesn't have 'Module' key, setting module to default."
		Dict['Module'] = 'Tactical.Projectiles.CRPTorpedo'
	else:
		#plugin dict has module, try to load it
		try:
			TorpModule = __import__(Dict['Module'])
			#print TorpModule
		except:
			print "Error:", Dict['ShipHardpoint'], "Special Weapon Plugin: Wasn't able to load torpedo module, setting module to default."
			Dict['Module'] = 'Tactical.Projectiles.CRPTorpedo'

	####################################################
	#check the plugin dict key SHOOTFROM
	if not Dict.has_key('ShootFrom') or Dict['ShootFrom'] == None:
		print "Error:", Dict['ShipHardpoint'], "Special Weapon Plugin: Doesn't have 'ShootFrom' key, setting location to shoot from to default."
		try:
			Dict['ShootFrom'] = pPlayer.GetTorpedoSystem().GetName()
		except:
			Dict['ShootFrom'] = pPlayer.GetHull().GetName()
	else:
		#plugin dict has shootfrom, check it
		ShootFrom = MissionLib.GetSubsystemByName(pPlayer, Dict['ShootFrom'])
		if ShootFrom == None: 
			print "Error:", Dict['ShipHardpoint'], "Special Weapon Plugin: Your ship doesn't have the Subsystem that matches your ship's CRP plugin file ShootFrom variable. Setting ShootFrom to default."
			try:
				Dict['ShootFrom'] = pPlayer.GetTorpedoSystem().GetName()
			except:
				Dict['ShootFrom'] = pPlayer.GetHull().GetName()	
	
	SWStatus = SW_OPERATIONAL
	IsSWOnline = SW_OFFLINE
	pPlayer.AddPythonFuncHandlerForInstance(App.ET_SUBSYSTEM_DISABLED, __name__ + ".SWDisabled")
	pPlayer.AddPythonFuncHandlerForInstance(App.ET_SUBSYSTEM_DESTROYED, __name__ + ".SWDestroyed")
	pPlayer.AddPythonFuncHandlerForInstance(App.ET_SUBSYSTEM_OPERATIONAL, __name__ + ".SWOperational")
	PluginDict = Dict
	return

#This is to set the global of CRP Status disabled. other functions will check it see if CRP can be used.
def SWDisabled(pObject, pEvent):
	global SWStatus, PluginDict, pSWStatBut
	pPlayer = MissionLib.GetPlayer()
	pSWSYS = MissionLib.GetSubsystemByName(pPlayer, PluginDict['ShootFrom'])
	if pSWSYS.GetObjID() == pEvent.GetSource().GetObjID():
		print "SW has been disabled."
		SWStatus = SW_DISABLED
		pSWStatBut.SetName(GetSWStatButString())

#This is to set the global of SW Status destroyed. other functions will check it see if SW can be used.
def SWDestroyed(pObject, pEvent):
	global SWStatus, PluginDict, pSWStatBut
	pPlayer = MissionLib.GetPlayer()
	pSWSYS = MissionLib.GetSubsystemByName(pPlayer, PluginDict['ShootFrom'])
	if pSWSYS.GetObjID() == pEvent.GetSource().GetObjID():
		print "SW has been destroyed."
		SWStatus = SW_DESTROYED
		pSWStatBut.SetName(GetSWStatButString())

#This is to set the global of CRP Status operational. other functions will check it see if CRP can be used.
def SWOperational(pObject, pEvent):
	global SWStatus, PluginDict, pSWStatBut
	pPlayer = MissionLib.GetPlayer()
	pSWSYS = MissionLib.GetSubsystemByName(pPlayer, PluginDict['ShootFrom'])
	if pSWSYS.GetObjID() == pEvent.GetSource().GetObjID():
		print "SW is operational again."
		SWStatus = SW_OPERATIONAL
		pSWStatBut.SetName(GetSWStatButString())

#For returning the StatButton string (a TGString object)
def GetSWStatButString():
	global IsSWOnline, SWStatus
	String = None
	if SWStatus == SW_DESTROYED:   
		String = App.TGString("Status: Destroyed")
	elif SWStatus == SW_DISABLED:
		String = App.TGString("Status: Disabled")
	elif SWStatus == SW_OPERATIONAL:
		if IsSWOnline == SW_CHARGING:
			String = App.TGString("Status: Charging")
		elif IsSWOnline == SW_ONLINE:
			String = App.TGString("Status: Looping")
		elif IsSWOnline == SW_OFFLINE:
			String = App.TGString("Status: Stand By")
	
	return String

# Building a menu
def BuildMenu():
	global pButton, pMenu, pSWStatBut
	# Building the SW menu
	pBridgeSet = App.g_kSetManager.GetSet('bridge' )
	pTacticalMenu = Lib.LibEngineering.GetBridgeMenu("Tactical") 
	pMenu = App.STMenu_CreateW(App.TGString("SpecialWeapon")) 
	pTacticalMenu.PrependChild(pMenu)

	pButton = Lib.LibEngineering.CreateMenuButton("Fire Special Weapon", "Tactical", __name__ + ".SpecialWeaponFire", 0, pMenu)
	pSWStatBut = Lib.LibEngineering.CreateMenuButton("Status: Stand By", "Tactical", __name__ + ".Nothing", 0, pMenu) 
	Lib.LibEngineering.AddKeyBind("Special Weapon", __name__ + ".SWKeyCheck", 0, "Ship")
	pButton.SetEnabled()


def RemoveMenu():
	pBridgeSet = App.g_kSetManager.GetSet('bridge')
	g_pPerson = App.CharacterClass_GetObject(pBridgeSet, "Tactical")
	pMenu = g_pPerson.GetMenu()
	if (pMenu != None):
		pButton = pMenu.GetSubmenu("SpecialWeapon")
		if (pButton != None):
			pMenu.DeleteChild(pButton)

# It returns the pShip(arg) HP, needed for plugin checking
def GetShipType(pShip):
                if pShip.GetScript():
                        return string.split(pShip.GetScript(), '.')[-1]
                return None

#If someone asks what this does, i'll personally hire a hitman to bring me your head
#so just BEHOLD!!! the most useful function of all times!!!
def Nothing(pObject, pEvent):
	return